#
# VHA6
#
# Copyright (c) 2019 Varnish Software AS
#
# Edgestash and JSON export
#

import edgestash;

# Export delimiters on broadcast

sub edgestash_broadcast_insert {
        if (edgestash.is_edgestash()) {
                http.req_set_header(9, "vha6-edgestash-sd", edgestash.get_sdelimiter("'"));
                http.req_set_header(9, "vha6-edgestash-ed", edgestash.get_edelimiter("'"));
        }
}

# Export on origin

sub vcl_deliver
{
	if (req.method == "VHA_FETCH") {
		unset resp.http.vha6-edgestash;
		unset resp.http.vha6-json;
		if (edgestash.is_edgestash()) {
			vha.log("VHA_FETCH ORIGIN: EDGESTASH export");
			set resp.http.vha6-edgestash = "true";
		}
		if (edgestash.is_json()) {
			vha.log("VHA_FETCH ORIGIN: JSON export");
			set resp.http.vha6-json = "true";
		}
	}
}

# Import on peer

sub vcl_backend_response
{
	if (bereq.method == "VHA_FETCH") {
		if (beresp.http.vha6-edgestash == "true") {
			vha.log("VHA_BROADCAST PEER: EDGESTASH import");
			edgestash.parse_response();
		}
		if (bereq.http.vha6-edgestash-sd || bereq.http.vha6-edgestash-ed) {
			edgestash.set_delimiter(bereq.http.vha6-edgestash-sd,
				bereq.http.vha6-edgestash-ed, "'");
		}
		if (beresp.http.vha6-json == "true") {
			vha.log("VHA_BROADCAST PEER: JSON import");
			edgestash.index_json();
		}

		unset beresp.http.vha6-edgestash;
		unset beresp.http.vha6-json;
	}
}

# EOF
