#
# VHA6
#
# Copyright (c) 2019 Varnish Software AS
#
# ESI export
# VCL 4.0
#

vcl 4.0;

# Export on origin

sub vcl_deliver {
	if (req.method == "VHA_FETCH") {
		unset resp.http.vha6-esi;
		if (vha.is_esi()) {
			vha.log("VHA_FETCH ORIGIN: ESI export");
			set resp.http.vha6-esi = "true";
			set req.esi = false;
		}
	}
}

# Import on peer

sub vcl_backend_response {
	if (bereq.method == "VHA_FETCH") {
		if (beresp.http.vha6-esi == "true") {
			vha.log("VHA_BROADCAST PEER: ESI import");
			set beresp.do_esi = true;
		}

		unset beresp.http.vha6-esi;
	}
}

# EOF
