#
# VHA6
#
# Copyright (c) 2019 Varnish Software AS
#
# Fast 304 export
#

import utils;

# Export on broadcast

sub fast_304_broadcast_insert {
        if (utils.is_fast_304()) {
                http.req_set_header(9, "vha6-fast304", utils.is_fast_304());
        }
}

# Import on peer using broadcast req

sub vcl_backend_response {
        if (bereq.method == "VHA_FETCH") {
                if (bereq.http.vha6-fast304 || vha6_opts.get("force_fast304") == "true") {
                        vha.log("VHA_BROADCAST PEER: Fast 304 import");
                        utils.fast_304();
                }
        }
}
