#
# VHA6
#
# Copyright (c) 2019 Varnish Software AS
#
# Core stevedore attribute export
#

# Export on origin

sub vcl_deliver {
	if (req.method == "VHA_FETCH") {
		vha.log("VHA_FETCH ORIGIN: STEVEDORE export");

		set resp.http.vha6-stevedore-ttl = vha.get_ttl_full() + "s";
		set resp.http.vha6-stevedore-ttl-rt = obj.ttl + "s";
		set resp.http.vha6-stevedore-grace = obj.grace + "s";
		set resp.http.vha6-stevedore-keep = obj.keep + "s";
		set resp.http.vha6-stevedore-uncacheable = obj.uncacheable;
		set resp.http.vha6-stevedore-storage = obj.storage;
		set resp.http.vha6-stevedore-age = resp.http.Age;
		set resp.http.vha6-stevedore-insert = vha.get_insertion_time();

		unset resp.http.X-Varnish;
		unset resp.http.Via;
		unset resp.http.Age;
	}
}

# Import on peer

sub vcl_backend_response {
	if (bereq.method == "VHA_FETCH") {
		vha.log("VHA_BROADCAST PEER: STEVEDORE import");

		set beresp.ttl = std.duration(beresp.http.vha6-stevedore-ttl, 0s);
		set beresp.grace = std.duration(beresp.http.vha6-stevedore-grace, 0s);
		set beresp.keep = std.duration(beresp.http.vha6-stevedore-keep, 0s);
		if (beresp.http.vha6-stevedore-uncacheable == "true") {
			set beresp.uncacheable = true;
		}
		set beresp.storage = vha.stevedore(beresp.http.vha6-stevedore-storage);
		vha.set_insertion_time(std.time(beresp.http.vha6-stevedore-insert, now));

		unset beresp.http.vha6-stevedore-ttl;
		unset beresp.http.vha6-stevedore-ttl-rt;
		unset beresp.http.vha6-stevedore-grace;
		unset beresp.http.vha6-stevedore-keep;
		unset beresp.http.vha6-stevedore-uncacheable;
		unset beresp.http.vha6-stevedore-storage;
		unset beresp.http.vha6-stevedore-age;
		unset beresp.http.vha6-stevedore-insert;
	}
}

# EOF
