#
# VHA6
#
# Copyright (c) 2019 Varnish Software AS
#
# XBody export
#

import xbody;

# Export on origin

sub vcl_deliver {
	if (req.method == "VHA_FETCH") {
		set resp.http.vha6-xbody = xbody.get_all();
		if (resp.http.vha6-xbody == "{}") {
			unset resp.http.vha6-xbody;
		} else {
			vha.log("VHA_FETCH ORIGIN: XBODY export");
		}
	}
}

# Import on peer

sub vcl_backend_response {
	if (bereq.method == "VHA_FETCH") {
		if (beresp.http.vha6-xbody) {
			vha.log("VHA_BROADCAST PEER: XBODY import");
			xbody.set(beresp.http.vha6-xbody);
		}

		unset beresp.http.vha6-xbody;
	}
}

# EOF
