#
# VHA6
#
# Copyright (c) 2019 Varnish Software AS
#
# YKey export
#

import ykey;

# Export on origin

sub vcl_deliver {
	if (req.method == "VHA_FETCH") {
		set resp.http.vha6-ykey = ykey.get_hashed_keys();
		if (resp.http.vha6-ykey == "") {
			unset resp.http.vha6-ykey;
		}
	}
}

# Import on peer

sub vcl_backend_response {
	if (bereq.method == "VHA_FETCH") {
		if (beresp.http.vha6-ykey) {
			vha.log("VHA_BROADCAST PEER: YKEY import");
			ykey.add_hashed_keys(beresp.http.vha6-ykey);
		}

		unset beresp.http.vha6-ykey;
	}
}

# EOF
