#
# VHA6
#
# Copyright (c) 2019 Varnish Software AS
#
# Firewall all VHA6 requests from parent VCL
#

sub vcl_recv {
	if (req.method ~ "^VHA") {
		return (synth(500, "FIREWALL RECV"));
	}
}

sub vcl_pipe {
	if (req.method ~ "^VHA") {
		return (synth(500, "FIREWALL PIPE"));
	}
}

sub vcl_pass {
	if (req.method ~ "^VHA") {
		return (synth(500, "FIREWALL PASS"));
	}
}

sub vcl_purge {
	if (req.method ~ "^VHA") {
		return (synth(500, "FIREWALL PURGE"));
	}
}

sub vcl_hit {
	if (req.method ~ "^VHA") {
		return (synth(500, "FIREWALL HIT"));
	}
}

sub vcl_miss {
	if (req.method ~ "^VHA") {
		return (synth(500, "FIREWALL MISS"));
	}
}

sub vcl_deliver {
	if (req.method ~ "^VHA") {
		return (synth(500, "FIREWALL DELIVER"));
	}
}

sub vcl_synth {
	if (req.method ~ "^VHA") {
		unset resp.http.vha6-seal;
		if (resp.status == 503 && !resp.http.vha6-error) {
			set resp.http.vha6-error = "ABANDON";
		}
		if (!resp.http.vha6-error) {
			set resp.http.vha6-error = resp.reason;
		}
		return (deliver);
	}
}

sub vcl_backend_fetch {
	if (bereq.method ~ "^VHA" || bereq.http.vha6-method) {
		return (abandon);
	}
}

sub vcl_backend_response {
	if (bereq.method ~ "^VHA" || bereq.http.vha6-method) {
		return (abandon);
	}
}

sub vcl_backend_error {
	if (bereq.method ~ "^VHA" || bereq.http.vha6-method) {
		return (abandon);
	}
}

# EOF
