#
# VHA6
#
# Copyright (c) 2019 Varnish Software AS
#
# Detect and disable legacy VHA (vha-agent)
#

sub vcl_recv {
	if (req.http.vha-origin) {
		vha.log("LEGACY VHA DETECTED");
		vha6_stats.counter("legacy_vha", 1, varnishstat = true);
		set req.http.vha-error = "VHA6 override";
		return (synth(500, "LEGACY VHA"));
	}
}

sub vcl_synth {
	if (resp.reason == "LEGACY VHA" && req.http.vha-error) {
		set resp.http.vha-error = req.http.vha-error;
		return (deliver);
	}
}

# EOF
